#!/usr/bin/python3
import socket
import ssl
import pprint
import sys

HOST=sys.argv[1]
PORT=int(sys.argv[2])

print("HOST:", HOST)
print("PORT:", PORT)

# default SSL context with the recommended security settings
# context = ssl.create_default_context(ssl.Purpose.SERVER_AUTH)
context = ssl.SSLContext(ssl.PROTOCOL_TLS)
context.verify_mode = ssl.CERT_REQUIRED
context.verify_flags = ssl.VERIFY_DEFAULT
context.check_hostname = True
context.load_default_certs() 
# context.load_verify_locations("ca.crt")

# context.check_hostname = True
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
conn = context.wrap_socket(s, server_hostname=HOST)
try:
    conn.connect((HOST, PORT))
except ssl.SSLError as e:
    print('SSLError', e)
    sys.exit(1)

cert = conn.getpeercert()
print("SERVER CERT:")
pprint.pprint(cert)
# request = b"HEAD / HTTP/1.0\r\nHost: " + HOST.encode() + b"\r\n\r\n"
request = b"GET / HTTP/1.0\r\nHost: " + HOST + b"\r\n\r\n"
print("REQUEST:")
print(request.decode())
conn.sendall(request)

answer = ''
while True:
    data = conn.recv(1024)
    if not data: break
    answer += data.decode()

print("ANSWER:")
print(answer)
conn.close()
